#include "ShaderConstants.fxh"
#include "Util.fxh"

struct PS_Input
{
    float4 position : SV_Position;
	float3 xyz : XYZ_POS;
    float2 uv : TEXCOORD_0_FB_MSAA;
};

struct PS_Output
{
    float4 color : SV_Target;
};
float Draw(float x,float y){

   return  1.0/sqrt(x*x+y*y);
   
}
void main( in PS_Input PSInput, out PS_Output PSOutput )
{
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE) || (VERSION < 0xa000 /*D3D_FEATURE_LEVEL_10_0*/) 
	float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
#else
	float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv);
#endif


float3 xyz = PSInput.xyz*10.0;

float Norain = pow(FOG_CONTROL.y,11.0);

float l = FOG_COLOR.r + FOG_COLOR.g + FOG_COLOR.b;

	float sun = 1.0 - clamp( dot(xyz,xyz/50.0), 0.0, 1.0 );
	diffuse = 0.0;
    diffuse += 0.2 * lerp(float4(1.1,1.1,1.1,1.0),float4(2.75,1.5,0.1,0.2),l*0.35) *  pow( sun,4.0 )*Norain;
	diffuse += 0.1 * lerp(float4(1.1,1.1,1.1,1.0),float4(2.75,1.5,0.1,0.2),l*0.35)    *  pow( sun, 2000.0 )*Norain;


diffuse += 2.0 * lerp(float4(1.1,1.1,1.1,1.0),float4(1.5,0.5,0.1,1.0),l*0.35) * Draw(xyz.x*30.0,xyz.z*30.0) * Norain;


#ifdef ALPHA_TEST
    if( diffuse.a < 0.5 )
    {
        discard;
    }
#endif
	PSOutput.color = diffuse;
}